----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    18:02:17 05/11/2015 
-- Design Name: 
-- Module Name:    counter_4b - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity counter_4b is
port (
	clk, reset 	: in STD_LOGIC;
	freeze, up_down	: in STD_LOGIC;
	count		: out unsigned(3 downto 0)
);
end counter_4b;


architecture Behavioral of counter_4b is

	signal counter : unsigned(3 downto 0);

begin

	count <= counter;

	process (clk, reset)
	begin
		if reset = '1' then
			counter <= (others => '0');
		elsif clk'event and clk = '1' then
			if (freeze = '0') then
				if (up_down = '0') then
					if counter = 15 then
						counter <= (others => '0');
					else
						counter <= counter + 1;
					end if;
				else
					if counter = 0 then
						counter <= (others => '1');
					else
						counter <= counter - 1;
					end if;
				end if;
			end if;
		end if;
	end process;


end Behavioral;

